明经CAD社区

 找回密码
 注册

QQ登录

只需一步,快速开始

搜索
查看: 1235|回复: 2

为何我全部缩放所有图元总提示有问题

[复制链接]
发表于 2012-6-1 14:10:16 | 显示全部楼层 |阅读模式
我想放大整个图形10倍,程序代码如下,但总有问题,请高手帮忙看看吧!
        public static void seAll(Point3d pt)
        {
            Document acDoc = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument;
            Database acCurDb = acDoc.Database;
            Editor ed = acDoc.Editor;
            Entity entity = null;
            DBObjectCollection EntityCollection = new DBObjectCollection();
            PromptSelectionResult ents = ed.SelectAll();
            if (ents.Status == PromptStatus.OK)
            {
                using (Transaction acTrans = acCurDb.TransactionManager.StartTransaction())
                {
                    BlockTable acBlkTbl;
                    acBlkTbl = acTrans.GetObject(acCurDb.BlockTableId, OpenMode.ForRead) as BlockTable;
                    BlockTableRecord acBlkTblRec;
                    acBlkTblRec = acTrans.GetObject(acBlkTbl[BlockTableRecord.ModelSpace], OpenMode.ForWrite) as BlockTableRecord;
                    SelectionSet ss = ents.Value;
                    foreach (ObjectId id in ss.GetObjectIds())
                    {
                        entity = acTrans.GetObject(id, OpenMode.ForWrite, true) as Entity;
                        if (entity != null)
                        {
                            entity.TransformBy(Matrix3d.Scaling(10, pt));
                            acBlkTblRec.AppendEntity(entity);
                            acTrans.AddNewlyCreatedDBObject(entity, true);
                        }
                    }
                    acTrans.Commit();
                }
            }
            else
            {
                ed.WriteMessage("全部图元选择失败");
            }

        }
总提示 acBlkTblRec.AppendEntity(entity);有问题,不知是什么原因

发表于 2012-6-1 14:14:43 | 显示全部楼层
你只是修改实体,你用acBlkTblRec.AppendEntity(entity);
                            acTrans.AddNewlyCreatedDBObject(entity, true);这两个函数干嘛?
实体已经存在,你重复添加当然会报错。
 楼主| 发表于 2012-6-1 14:24:11 | 显示全部楼层
sieben 发表于 2012-6-1 14:14
你只是修改实体,你用acBlkTblRec.AppendEntity(entity);
                            acTrans.AddNewlyC ...

谢谢,搞定了!
您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号 )  
©2000-2023 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2024-11-25 17:54 , Processed in 0.153962 second(s), 24 queries , Gzip On.

Powered by Discuz! X3.4

Copyright © 2001-2021, Tencent Cloud.

快速回复 返回顶部 返回列表